#ifndef _KGR_PATCH_BSC1031660_H
#define _KGR_PATCH_BSC1031660_H

#include <linux/if_packet.h>
#include <linux/net.h>

int kgr_patch_bsc1031660_init(void);
void kgr_patch_bsc1031660_cleanup(void);
int kgr_packet_set_ring(struct sock *sk, union tpacket_req_u *req_u,
	int closing, int tx_ring);
int kgr_packet_setsockopt(struct socket *sock, int level, int optname,
	char __user *optval, unsigned int optlen);
int kgr_packet_bind_spkt(struct socket *sock, struct sockaddr *uaddr,
			 int addr_len);
int kgr_packet_bind(struct socket *sock, struct sockaddr *uaddr, int addr_len);

#define KGR_PATCH_BSC1031660_FUNCS						\
	KGR_PATCH_OBJ(packet_set_ring, kgr_packet_set_ring, "af_packet"),	\
	KGR_PATCH_OBJ(packet_setsockopt, kgr_packet_setsockopt, "af_packet"),	\
	KGR_PATCH_OBJ(packet_bind_spkt, kgr_packet_bind_spkt, "af_packet"),	\
	KGR_PATCH_OBJ(packet_bind, kgr_packet_bind, "af_packet"),

#endif
